## patoline-0.1.tar.gz

=== Hyphenation/Makefile ===
FILES=$(shell ls *.tex)
DICTS=${FILES:.tex=.hdict}

CESURE=../src/cesure/cesure

all: ${DICTS}

%.hdict: %.tex
	${CESURE} $<

clean:
	- rm *.hdict

=== emacs/Makefile ===

all: patoline-input.el

SubstKey:
	ocamlfind ocamlopt -package str,camomile SubstKey.ml -linkpkg -o SubstKey

SubSuper2.el: SubSuper.el ../src/quail.el SubstKey
	./SubstKey ../src/quail.el SubSuper.el > SubSuper2.el

patoline-input.el:  patoline-input.pre ../src/quail.el SubSuper2.el patoline-input.post
	cat patoline-input.pre ../src/quail.el SubSuper2.el patoline-input.post > patoline-input.el

clean:
	rm SubSuper2.el SubstKey patoline-input.el

=== examples/Makefile ===
all:

slides:
	../src/Patoline/patoline --recompile --format FormatSlides --driver Net -I ../src --ml slides.txp
	ocamlfind ocamlopt -package camomile -linkpkg -I ../src/Format -I ../src/Drivers -I ../src/Typography -I ../src/Rbuffer rbuffer.cmxa Typography.cmxa SVG.cmxa Pdf.cmxa Net.cmxa DefaultFormat.cmxa FormatSlides.cmxa -linkpkg  -o 'slides.tmx'  -impl 'slides.tml'
	./slides.tmx --extra-plugins-dir ../src/Drivers

	ocamlfind ocamlopt -o test -package "netstring,netsys,unix,nethttpd,netcgi2,cryptokit" -thread -linkpkg slides.ml


clean:
	rm *.tml *.cm[ioax]

=== src/Makefile ===
include Makefile.config

FORMAT=$(shell cd Format; ls Format*.ml) LMFormat.ml

ifdef PACK_DRIVER_DriverGL
NATIVE_EXTRA+=Patoline/PatolineGL
endif

ifdef PACK_DRIVER_DriverGL2
NATIVE_EXTRA+=Patoline/PatolineGL2
endif

CAMLOPT=ocamlfind ocamlopt $(PACK)
CAMLC=ocamlfind ocamlc $(PACK)

VPATH=Typography:Pdf:Drivers:Format:cesure

all:native $(BIBI)

native:Typography/_build/Typography.cmxa Typography/_build/ParseMainArgs.cmx $(addprefix Format/,$(FORMAT:.ml=.cmxa)) $(DRIVERS) proof/proof Pdf/_build/pdf_parser.cmxa plot/plot.cmxa $(PATOLINE) $(NATIVE_EXTRA) cesure/cesure DefaultGrammar.tgx all_plugins


byte:Typography/_build/Typography.cma Typography/_build/ParseMainArgs.cmo $(addprefix Format/,$(FORMAT:.ml=.cma)) $(DRIVERS:.cmxa=.cma) Pdf/_build/pdf_parser.cma plot/plot.cma

prof:Typography/_build.p/Typography.p.cmxa $(addprefix Format/,$(FORMAT:.ml=.p.cmxa)) Pdf/_build/pdf_parser.p.cmxa plot/plot.p.cmxa

all_plugins:plugins Patoline/patoline
	make -C plugins all

Patoline/patoline:Patoline
	make -C Patoline patoline
Patoline/PatolineGL:Patoline Drivers/DriverGL.cmxa
	make -C Patoline PatolineGL
Patoline/PatolineGL2:Patoline GL2.cmxa
	make -C Patoline PatolineGL2

cesure/cesure:Typography/_build/Typography.cmxa cesure/cesure.ml
	make -C cesure cesure

hdicts:
	make -C ../Hyphenation

ocaml-bibi/bibi.cma:Typography/_build/Typography.cma ocaml-bibi Format/DefaultFormat.cma
	make -C ocaml-bibi bibi.cma
ocaml-bibi/bibi.cmxa:Typography/_build/Typography.cmi ocaml-bibi Format/DefaultFormat.cmxa
	make -C ocaml-bibi bibi.cmxa
ocaml-bibi/bibi.p.cmxa:Typography/_build.p/Typography.p.cmxa ocaml-bibi Format/DefaultFormat.p.cmxa
	make -C ocaml-bibi bibi.p.cmxa


proof/proof:Drivers/Pdf.cmxa proof/proof.ml Rbuffer/rbuffer.cmxa
	cd proof; $(CAMLOPT) -I ../Typography/_build -I ../Drivers -I ../Rbuffer -linkpkg -o proof rbuffer.cmxa ../Typography/_build/Typography.cmxa ../Drivers/Pdf.cmxa proof.ml


Pdf/_build/pdf_parser.cmxa:Typography/_build/Typography.cmxa
	make -C Pdf pdf_parser.cmxa
Pdf/_build/pdf_parser.cma:Typography/_build/Typography.cma
	make -C Pdf pdf_parser.cma
Pdf/_build/pdf_parser.p.cmxa:Typography/_build.p/Typography.p.cmxa
	make -C Pdf pdf_parser.p.cmxa

Format/DefaultFormat.cmxa:Format Typography/_build/Typography.cmxa
	make -C Format DefaultFormat.cmxa
Format/DefaultFormat.cma:Format Typography/_build/Typography.cma
	make -C Format DefaultFormat.cma

Format/DefaultFormat.p.cmxa:Format Typography/_build.p/Typography.p.cmxa
	make -C Format DefaultFormat.p.cmxa

Format/%.cmxa:Format/DefaultFormat.cmxa Typography/_build/Typography.cmxa Format/%.ml
	make -C Format $(shell basename $@)
Format/%.p.cmxa:Format/DefaultFormat.p.cmxa Typography/_build.p/Typography.p.cmxa Format/%.ml
	make -C Format $(shell basename $@)
Format/%.cma:Format/DefaultFormat.cma Typography/_build/Typography.cma Format/%.ml
	make -C Format $(shell basename $@)

.PHONY:Typography/_build/Typography.cma Typography/_build/Typography.cmxa Typography/_build.p/Typography.p.cmxa
Typography/_build/Typography.cma:Rbuffer/rbuffer.cma
	make -C Typography _build/Typography.cma
Typography/_build/Typography.cmxa:Rbuffer/rbuffer.cmxa
	make -C Typography _build/Typography.cmxa
Typography/_build.p/Typography.p.cmxa:Rbuffer/rbuffer.p.cmxa
	make -C Typography _build.p/Typography.p.cmxa

Typography/_build/Typography.cmi:Typography/_build/Typography.cma

.PHONY:Typography/_build/ParseMainArgs.cmo Typography/_build/ParseMainArgs.cmx Typography/_build.p/ParseMainArgs.p.cmx
Typography/_build/ParseMainArgs.cmo:Rbuffer/rbuffer.cmo
	make -C Typography _build/ParseMainArgs.cmo
Typography/_build/ParseMainArgs.cmx:Rbuffer/rbuffer.cmx
	make -C Typography _build/ParseMainArgs.cmx
Typography/_build.p/ParseMainArgs.p.cmx:Rbuffer/rbuffer.p.cmx
	make -C Typography _build.p/ParseMainArgs.p.cmx

Rbuffer/rbuffer.cma:Rbuffer
	make -C Rbuffer rbuffer.cma
Rbuffer/rbuffer.cmxa:Rbuffer
	make -C Rbuffer rbuffer.cmxa
Rbuffer/rbuffer.p.cmxa:Rbuffer
	make -C Rbuffer rbuffer.p.cmxa

Drivers/%.cmxa:Typography/_build/Typography.cmxa Drivers
	make -C Drivers $(shell basename $@)
Drivers/%.cma:Typography/_build/Typography.cma Drivers
	make -C Drivers $(shell basename $@)
Drivers/%.p.cmxa:Typography/_build.p/Typography.p.cmxa Drivers
	make -C Drivers $(shell basename $@)

#Drivers/Typography.cmi:Typography/_build/Typography.cmi
#	cp Typography/_build/Typography.cmi Drivers

plot/plot.cmxa:plot Format/DefaultFormat.cmxa
	make -C plot plot.cmxa
plot/plot.cma:plot Format/DefaultFormat.cmaa
	make -C plot plot.cma
plot/plot.p.cmxa:plot Format/DefaultFormat.p.cmxa
	make -C plot plot.p.cmxa

DefaultGrammar.tgx:DefaultGrammar.pdf

DefaultGrammar.pdf:DefaultGrammar.txp Patoline/patoline
	Patoline/patoline --main-ml --driver Pdf -o DefaultGrammar_.tml DefaultGrammar.txp
	Patoline/patoline --ml --driver Pdf -o DefaultGrammar.ttml DefaultGrammar.txp
	ocamlfind ocamlopt $(PACK) -I Format -I Typography/_build Typography.cmxa -c -o DefaultGrammar.cmx -impl DefaultGrammar.ttml
	ocamlfind ocamlopt $(PACK) -I Rbuffer -I Format -I Drivers -I Typography/_build rbuffer.cmxa Typography.cmxa DefaultFormat.cmxa Pdf.cmxa -linkpkg -o DefaultGrammar.tmx ParseMainArgs.cmx DefaultGrammar.cmx -impl DefaultGrammar_.tml
	./DefaultGrammar.tmx --extra-fonts-dir ../Fonts --extra-hyph-dir ../Hyphenation

.PHONY: test.pdf test

test.pdf:test.txp Format/DefaultFormat.cmxa Drivers/Pdf.cmxa
	Patoline/patoline --ml test.txp
	$(CAMLOPT) -o test.tmx -I Rbuffer -I Typography/_build -I Format -I Drivers -I Rbuffer rbuffer.cmxa Typography.cmxa DefaultFormat.cmxa str.cmxa FormatThese.cmxa Pdf.cmxa -linkpkg -impl test.tml
	./test.tmx

test:test.txp Format/DefaultFormat.cmxa Format/FormatSlides.cmxa Drivers/SVG.cmxa
	Patoline/patoline --ml test.txp
	$(CAMLOPT) -o test.tmx -I Rbuffer -I Typography/_build -I Format -I Drivers -I Rbuffer rbuffer.cmxa Typography.cmxa DefaultFormat.cmxa str.cmxa FormatSlides.cmxa SVG.cmxa -linkpkg -impl test.tml
	./test.tmx



.PHONY :doc
doc:
	make -C Typography doc

install:
	make -C .. install

clean:
	make -C Rbuffer clean
	make -C Typography clean
	make -C Format clean
	make -C Drivers clean
	make -C Patoline clean
	make -C ocaml-bibi clean
	make -C Pdf clean
	make -C cesure clean
	make -C Rbuffer clean
	make -C ../emacs clean
	cd Drivers; rm -f *~ \#*\# *.cm[xoia] *.cmxa *.o *.a
	cd proof; rm -f *~ \#*\# *.cm[xoi] *.o
	rm -f *~ \#*\# *.cm[xoia] *.cmxa *.tgo *.tgx *.tml *.ttml *.o *.a *.tmx

=== tests/Makefile ===
.PHONY:articles

all:articles

articles:
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts --format FormatArticle min.txp
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts --format FormatArticle TD1.txp
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts test_delimiters.txp
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts test_small_fraction.txp
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts test_virgule.txp
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts test_break_badness.txp
	../src/Patoline/patoline --recompile -I ../src --extra-hyph-dir ../Hyphenation --extra-fonts-dir ../Fonts test_distance.txp

=== src/Drivers/Makefile ===
include ../Makefile.config

ifdef PACK_DRIVER_DriverGL
PACK:=$(PACK) -package $(PACK_DRIVER_DriverGL)
NATIVE_EXTRA+=Patoline/PatolineGL
endif
ifdef PACK_DRIVER_GL2
PACK:=$(PACK) -package $(PACK_DRIVER_DriverGL2)
NATIVE_EXTRA+=Patoline/PatolineGL2
endif

CAMLOPT=ocamlfind ocamlopt $(PACK) -pp $(CPP) -I ../Typography/_build -I ../Rbuffer -I ../Patoline
CAMLMKLIB=ocamlfind ocamlmklib $(PACK) -I ../Typography/_build -I ../Rbuffer -I ../Patoline
CAMLC=ocamlfind ocamlc $(PACK) -pp $(CPP) -I ../Typography/_build -I ../Rbuffer -I ../Patoline


UNAME := $(shell uname)

ifeq ($(UNAME), Linux)
CFLAGS=-fPIC
endif
ifeq ($(UNAME), Darwin)
CFLAGS=-I$(shell ocamlc -where) -fPIC # -framework GLUT -framework OpenGL
endif

Html.cmxa:Html.cmx ../Typography/_build/Typography.cmi
	$(CAMLOPT) -a -o $@ HtmlFonts.cmx SVG.cmx Html.cmx
SVG.cmxa:SVG.cmx HtmlFonts.cmx ../Typography/_build/Typography.cmi
	$(CAMLOPT) -a -o $@ HtmlFonts.cmx SVG.cmx
DriverGL.cmxa:DriverGL.cmx FrameBuffer.o GlFBO.cmx  ../Typography/_build/Typography.cmi
	$(CAMLMKLIB) -package str -o DriverGL FrameBuffer.o GlFBO.cmx Vec3.cmx DriverGL.cmx
Image.cmxa:DriverGL.cmx Image.cmx ../Typography/_build/Typography.cmi
	$(CAMLMKLIB) -o Image FrameBuffer.o DriverGL.cmx Language.cmx Image.cmx
Pdf.cmxa:Pdf.cmx ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -a -o $@ Pdf.cmx
Bin.cmxa:Bin.cmx ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -a -o $@ Bin.cmx
DriverGL2.cmxa:DriverGL2.cmx ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -a -o $@ DriverGL2.cmx
Net.cmxa:Net.cmx ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -a -o $@ Net.cmx
None.cmxa:None.cmx ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -a -o $@ None.cmx

DriverCairo.cmxa:DriverCairo.cmx ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -a -o $@ DriverCairo.cmx

DriverCairo.cmx:DriverCairo.ml ../Typography/_build/Typography.cmx
	$(CAMLOPT) -package cairo -c -o $@ DriverCairo.ml

Html.cmx:Html.ml SVG.cmx HtmlFonts.cmx
SVG.cmx:SVG.ml HtmlFonts.cmx
Net.cmx:Net.ml SVG.cmx HtmlFonts.cmx
DriverGL.cmx:DriverGL.ml FrameBuffer.o GlFBO.cmx Vec3.cmx
	$(CAMLOPT) -package $(PACK_DRIVER_DriverGL) -c -o $@ $<
Image.cmx:Image.ml DriverGL.cmx ../Patoline/Language.cmx
GLNet.cmx:GLNet.ml
	$(CAMLOPT) $(PACK_DRIVER_GL) -c -o $@ $<

%.cmx:%.ml ../Typography/_build/Typography.cmi ../Typography/_build/Typography.cmx
	$(CAMLOPT) -c -o $@ $<

clean:
	rm -f *.cm[aoix] *.cmxa *.o *.so *.a *~ \#*\#

=== src/Format/Makefile ===
include ../Makefile.config

CAMLOPT=ocamlfind ocamlopt -pp "cpp -w" -I ../Typography/_build -I ../Rbuffer $(PACK)
CAMLC=ocamlfind ocamlc -pp "cpp -w" -I ../Typography/_build -I ../Rbuffer $(PACK)

all:

DefaultFormat.cmxa:Euler.ml Numerals.ml TableOfContents.ml DefaultFormat.ml ../Typography/_build/Typography.cmi ../Typography/_build/Typography.cmx
	$(CAMLOPT) -a -o $@ Euler.ml Numerals.ml TableOfContents.ml DefaultFormat.ml

DefaultFormat.cma:Euler.ml Numerals.ml TableOfContents.ml DefaultFormat.ml ../Typography/_build/Typography.cmi ../Typography/_build/Typography.cmo
	$(CAMLC) -a -o $@ Euler.ml Numerals.ml TableOfContents.ml DefaultFormat.ml

DefaultFormat.p.cmxa:Euler.ml Numerals.ml TableOfContents.ml DefaultFormat.ml  ../Typography/_build/Typography.cmi ../Typography/_build/Typography.cmx
	$(CAMLOPT) -p -a -o $@ Euler.ml Numerals.ml TableOfContents.ml DefaultFormat.ml

%.cmxa:DefaultFormat.cmxa %.ml
	$(CAMLOPT) -a -o $@ $*.ml

%.cma:DefaultFormat.cma %.ml
	$(CAMLC) -a -o $@ $*.ml

%.p.cmxa:DefaultFormat.p.cmxa %.ml
	$(CAMLOPT) -p -a -o $@ $*.ml


clean:
	rm -Rf *~ *.cm[oixa] *.cmxa

=== src/Patoline/Makefile ===
include ../Makefile.config

CAMLOPT=ocamlfind ocamlopt -pp $(CPP) $(PACKAGE_DYP) -package camomile -I ../Rbuffer
CAMLC=ocamlfind ocamlc -pp $(CPP) $(PACKAGE_DYP) -package camomile -I ../Rbuffer

patoline: Language.cmx Config.cmx Parser.cmx Generateur.cmx SimpleGenerateur.cmx Main.cmx
	$(CAMLOPT) -linkpkg -o patoline -I +threads str.cmxa threads.cmxa rbuffer.cmxa dynlink.cmxa Util.cmx Language.cmx Config.cmx Build.cmx Parser.cmx Generateur.cmx SimpleGenerateur.cmx Main.cmx

PatolineGL:PatolineGL.ml ../Typography/_build/Typography.cmxa
	$(CAMLOPT) -package $(PACK_DRIVER_DriverGL) -linkpkg -I ../Rbuffer -I ../Drivers ../Rbuffer/rbuffer.cmxa ../Typography/_build/Typography.cmxa DriverGL.cmxa  -o $@ $<

PatolineGL2:PatolineGL2.ml ../Typography/_build/Typography.cmxa ../Drivers/GL2.cmxa
	$(CAMLOPT) -package $(PACK_DRIVER_GL2) -linkpkg -I ../Rbuffer -I ../Drivers ../Rbuffer/rbuffer.cmxa ../Typography/_build/Typography.cmxa gtkInit.cmx GL2.cmxa  -o $@ $<

Main.cmx:Generateur.cmx SimpleGenerateur.cmx Main.ml Build.cmx
	ocamlopt -thread -rectypes -I +threads -c -o Main.cmx Main.ml

Generateur.cmx:Parser.cmx Generateur.ml Build.cmx
Parser.cmx:Parser.ml Config.cmx Language.cmx Util.cmx Build.cmx
SubSuper.dyp:UnicodeScripts.ml UnicodeData.txt
	$(CAMLC) -o UnicodeScripts -package bigarray -package camomile -linkpkg UnicodeScripts.ml
	./UnicodeScripts
Parser.ml:Parser.dyp SubSuper.dyp
	cat  Parser.dyp SubSuper.dyp > tmp.dyp
	dypgen --no-mli --merge-warning tmp.dyp
	mv tmp.ml Parser.ml

Parser.cmx:Parser.ml
	$(CAMLOPT) -rectypes -c -o $@ $<
Generateur.cmx:Generateur.ml
	$(CAMLOPT) -rectypes -c -o $@ $<

%.cmx:%.ml
	$(CAMLOPT) -c -o $@ $<
Util.cmi:Util.cmx

Build.cmx:Build.ml Util.cmx
	$(CAMLOPT) -thread -c -o $@ $<

clean:
	- rm -f *~ \#*\# *.o *.cm[iox] Parser.ml SubSuper.dyp patoline PatolineGL PatolineGL2

=== src/Pdf/Makefile ===
OCAMLOPT=ocamlfind ocamlopt -package camlzip -I ../Typography/_build
OCAMLC=ocamlfind ocamlc -package camlzip -I ../Typography/_build

pdf_parser.cmxa:pdfutil.cmx obj_lexer.cmx obj_parser.cmx pdf_parser.cmx
	$(OCAMLOPT) -a -o pdf_parser.cmxa pdfutil.cmx obj_lexer.cmx obj_parser.cmx pdf_parser.cmx

pdf_parser.p.cmxa:pdfutil.p.cmx obj_lexer.p.cmx obj_parser.p.cmx pdf_parser.p.cmx
	$(OCAMLOPT) -p -a -o pdf_parser.p.cmxa pdfutil.p.cmx obj_lexer.p.cmx obj_parser.p.cmx pdf_parser.p.cmx

pdf_parser.cma:pdfutil.cmo obj_lexer.cmo obj_parser.cmo pdf_parser.cmo
	$(OCAMLC) -a -o pdf_parser.cma pdfutil.cmo obj_lexer.cmo obj_parser.cmo pdf_parser.cmo

pdf_parser.cmx:obj_parser.cmx obj_lexer.cmx
pdf_parser.p.cmx:obj_parser.p.cmx obj_lexer.p.cmx
pdf_parser.cmo:obj_parser.cmo obj_lexer.cmo
obj_lexer.ml:obj_parser.cmo
obj_parser.mly:pdfutil.cmo
obj_parser.cmo:obj_parser.cmi
obj_parser.cmi:obj_parser.mli
obj_parser.mli:obj_parser.ml
obj_parser.cmx:obj_parser.cmi
obj_parser.p.cmx:obj_parser.cmi

%.ml:%.mly
	ocamlyacc $<

%.ml:%.mll
	ocamllex -o $@ $<

%.cmx:%.ml
	$(OCAMLOPT) -c -o $@ $<
%.p.cmx:%.ml
	$(OCAMLOPT) -p -c -o $@ $<
%.cmo:%.ml
	$(OCAMLC) -c -o $@ $<
%.cmi:%.mli
	$(OCAMLC) -c -o $@ $<

clean:
	rm -Rf *~ *.o *.cm[xaoi] *.cmxa *.a

=== src/Rbuffer/Makefile ===
INST=$(DESTDIR)$(shell ocamlfind printconf destdir)/rbuffer


all:rbuffer.cmxa rbuffer.p.cmxa rbuffer.cma rope.cmxa rope.p.cmxa rope.cma

rbuffer.cmxa:rbuffer.ml rbuffer.cmi rope.cmi
	ocamlopt -a -o $@ $<
rbuffer.p.cmxa:rbuffer.ml rbuffer.cmi rope.cmi
	ocamlopt -p -a -o $@ $<

rbuffer.cma:rbuffer.ml rbuffer.cmi rope.cmi
	ocamlc -a -o $@ $<

rope.cmxa:rope.ml rope.cmi
	ocamlopt -a -o $@ $<
rope.p.cmxa:rope.ml rope.cmi
	ocamlopt -p -a -o $@ $<

rope.cma:rope.ml rope.cmi
	ocamlc -a -o $@ $<

%.cmi:%.mli
	ocamlc -o $@ $<

install:rbuffer.cmxa rbuffer.p.cmxa rbuffer.cma rope.cmxa rope.p.cmxa rope.cma
	install -p -d $(INST)
	install -p rbuffer.cmxa rbuffer.p.cmxa rbuffer.a rbuffer.cmi rbuffer.cma $(INST)
	install -p rope.cmxa rope.p.cmxa rope.a rope.cmi rope.cma $(INST)
	install -p META $(INST)

clean:
	rm -f *~ *.cm[oixa] *.a *.cmxa *.o

=== src/Typography/Makefile ===
include ../Makefile.config

CAMLOPT=ocamlfind ocamlopt -pp $(CPP) -I Fonts -I Output -I Fonts/Sfnt -I ../Rbuffer $(PACK)
CAMLC=ocamlfind ocamlc -pp $(CPP) -I Fonts -I Output -I Fonts/Sfnt -I ../Rbuffer $(PACK)

DOCDIR=Typography.doc
CAMLDOC=ocamlfind ocamldoc -d $(DOCDIR) -html -charset UTF-8 -package camomile,rbuffer -rectypes -pp 'cpp -C -w' -I _build -I _build/Output -I _build/Fonts

FILES=$(shell ls *.ml */*.ml */*/*.ml) $(shell ls *.mli */*.mli */*/*.mli)

_build/Typography.cmxa:_build/Typography.cmx
	cd _build;ocamlopt -a -o Typography.cmxa Typography.cmx
_build/Typography.cmx: $(FILES) ../Rbuffer/rbuffer.cmxa
	ocamlbuild -use-ocamlfind -classic-display Typography.cmx
_build/ParseMainArgs.cmx:_build/Typography.cmxa
	ocamlbuild -use-ocamlfind -classic-display ParseMainArgs.cmx

_build/Typography.cma:_build/Typography.cmo
	cd _build;ocamlc -a -o Typography.cma Typography.cmo
_build/Typography.cmo: $(FILES) ../Rbuffer/rbuffer.cma
	ocamlbuild -use-ocamlfind -classic-display Typography.cmo
_build/ParseMainArgs.cmo:_build/Typography.cma
	ocamlbuild -use-ocamlfind -classic-display ParseMainArgs.cmo

_build.p/Typography.p.cmxa:_build.p/Typography.p.cmx
	cd _build.p;ocamlopt -a -o Typography.p.cmxa Typography.p.cmx
_build.p/Typography.p.cmx: $(FILES) ../Rbuffer/rbuffer.cmxa
	ocamlbuild -build-dir _build.p -use-ocamlfind -classic-display Typography.p.cmx
_build/ParseMainArgs.p.cmx:_build.p/Typography.p.cmxa
	ocamlbuild -use-ocamlfind -classic-display ParseMainArgs.p.cmx

doc:
	mkdir -p $(DOCDIR)
	$(CAMLDOC) $(FILES)



clean:
	rm -Rf _build

=== src/cesure/Makefile ===
include ../Makefile.config
CAMLOPT=ocamlfind ocamlopt $(PACK)

cesure:cesure.ml
	$(CAMLOPT) -I ../Typography/_build -I ../Rbuffer -o cesure rbuffer.cmxa Typography.cmxa str.cmxa -linkpkg cesure.ml

clean:
	- rm cesure *.cmx *.o *.cmi *.cmo

=== debian/changelog ===
patoline (0~20121030) unstable; urgency=low

  * Sync with upstream

 -- Florian Hatat <florian.hatat@univ-savoie.fr>  Tue, 30 Oct 2012 10:32:36 +0100

patoline (0~20120715) unstable; urgency=low

  * Update patoline sources.
  * New trigger to generate ocamlfind's META file in libtypography-ocaml-dev.
  * Add patoline-driver-gl.
  * Add patoline-mode.

 -- Florian Hatat <florian.hatat@univ-savoie.fr>  Sun, 15 Jul 2012 19:43:32 +0200

patoline (0~20120621) unstable; urgency=low

  * New upstream with math kerning and a new patofig.
  * Forgot dypgen in Build-depends.

 -- Florian Hatat <florian.hatat@univ-savoie.fr>  Thu, 21 Jun 2012 11:14:16 +0200

patoline (0~20120615) unstable; urgency=low

  * Sync with upstream.
  * Build only bytecode when ocamlopt is unavailable.
  * Try to comply with OCaml Task Force policy.

 -- Florian Hatat <florian.hatat@univ-savoie.fr>  Sat, 16 Jun 2012 15:00:53 +0200

patoline (0~20120610) unstable; urgency=low

  * New upstream release.

 -- Florian Hatat <florian.hatat@univ-savoie.fr>  Sun, 10 Jun 2012 20:37:28 +0200

patoline (0~20120423) unstable; urgency=low

  * Initial release.

 -- Pierre-Etienne Meunier <pierreetienne.meunier@gmail.com>  Mon, 23 Apr 2012 20:37:28 +0200

=== debian/control ===
Source: patoline
Section: ocaml
Priority: extra
Maintainer: Florian Hatat <florian.hatat@univ-savoie.fr>
Uploaders: Tom Hirschowitz <tom.hirschowitz@univ-savoie.fr>
Build-Depends: debhelper (>= 7.0.50~), dh-ocaml, ocaml-base-nox, ocaml-findlib, dypgen (>= 0.20120619), libcamomile-ocaml-dev, ocaml-findlib, libzip-ocaml-dev, libcamlimages-ocaml-dev, liblablgtk2-gl-ocaml-dev, liblablgl-ocaml-dev, libcairo-ocaml-dev, libsqlite3-ocaml-dev, libocamlnet-ocaml-dev, libcryptokit-ocaml-dev
Standards-Version: 3.9.3
Homepage: http://www.patoline.com/

Package: patoline
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${F:OCamlRun}, libdypgen-ocaml-dev (>= 0.20120619), libcamomile-ocaml-dev, ocaml-findlib, patoline-fonts, libtypography-ocaml-dev, libzip-ocaml, libcamlimages-ocaml
Description: Digital typography system written in OCaml
 Patoline is a digital typography system, similar to TeX or Microsoft Word, but
 using an up-to-date language and algorithm, and leveraging the power of
 present-day computers. In particular:
 .
  * The amount of memory we have today is in no way comparable to what Knuth
    had when he first wrote TeX in the 1970s.
  * Also, the choice of our favourite programming language is no more limited
    by "what compiles on all machines of the laboratory".
  * The global network has changed: today, nobody knows anyone on the net.

Package: patoline-driver-gl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${F:OCamlRun}, patoline, liblablgl-ocaml-dev
Description: OpenGL output driver for Patoline

Package: patoline-fonts
Architecture: all
Section: fonts
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-oflb-asana-math | ttf-oflb-asana-math
Description: Fonts for patoline
 This package contains core OpenType fonts for typesetting texts
 using Patoline.

Package: libtypography-ocaml-dev
Architecture: any
Depends:  ${shlibs:Depends}, ${misc:Depends}, ${F:OCamlRun}, libdypgen-ocaml-dev (>= 0.20120619), libcamomile-ocaml-dev, ocaml-findlib, libzip-ocaml-dev, libcamlimages-ocaml-dev
Description: Library of typographic primitives for OCaml

Package: patoline-mode
Architecture: all
Depends: xemacs21-nomule | emacsen
Recommends: patoline, patoline-driver-gl
Description: Emacs mode for Patoline
Enhances: patoline

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

include /usr/share/ocaml/ocamlvars.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Ignore "make check" for the moment, as building DefaultGrammar.pdf may
# fail.
export DEB_BUILD_OPTIONS=nocheck

OCAMLABI:=$(shell ocamlc -version)
BYTECODE =$(shell [ -x /usr/bin/ocamlopt ] || echo yes)
OCAMLRUN =$(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))

%:
	dh $@

get-orig-source:
	darcs pull

override_dh_auto_configure:
	ocaml configure.ml --prefix /usr --ocaml-libs /usr/lib/ocaml --ocamlfind-dir /usr/lib/ocaml --fonts-dir /usr/share/fonts/opentype

override_dh_install:
	dh_install -XAsana-Math.otf

build-stamp:
	dh_testdir

	if [ -x /usr/bin/ocamlopt ]; then \
		$(MAKE) -C src all; \
	else \
		$(MAKE) -C src byte; \
	fi

override_dh_gencontrol:
	dh_gencontrol -- -VF:OCamlRun="$(OCAMLRUN)"
